//@author: vux
//@help: template for standard shaders
//@tags: template
//@credits: 

Texture2D texture2d <string uiname="Texture";>;

SamplerState linearSampler : IMMUTABLE
{
    Filter = MIN_MAG_MIP_POINT;
    AddressU = Clamp;
    AddressV = Clamp;
};
 
cbuffer cbPerDraw : register( b0 )
{
	float4x4 tVP : LAYERVIEWPROJECTION;	
};

cbuffer cbPerObj : register( b1 )
{
	float4x4 tW : WORLD;
	float4 cAmb <bool color=true;String uiname="Color";> = { 1.0f,1.0f,1.0f,1.0f };
};

struct VS_IN
{
	uint vi : SV_VertexID;
	float4 PosO : POSITION;
	float4 TexCd : TEXCOORD0;

};

struct vs2ps
{
    float4 PosWVP: SV_Position;
	float4 Color: Color;
    float4 TexCd: TEXCOORD0;
};

struct CustomVertex
{
	float3 Position;
	float pad0;
	float4 Color;
	float4x4 rot;
};

StructuredBuffer<CustomVertex> VertexBufferStructured;

vs2ps VS(VS_IN input)
{
    vs2ps output;
	CustomVertex v = VertexBufferStructured[input.vi];
    output.PosWVP  = mul(float4(v.Position, 1), mul(mul(tW, transpose(v.rot)), tVP));
	//output.PosWVP  = mul(input.PosO, mul(tW, tVP));
	output.Color = v.Color;
    output.TexCd = input.TexCd;
    return output;
}

float4 PS(vs2ps In): SV_Target
{
    float4 col = In.Color;
    return col;
}


technique10 ConstantStructured
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}




